package com.dbxml.db.client.tools.command;

/*
 * dbXML - Native XML Database
 * Copyright (C) 1999-2004  The dbXML Group, L.L.C.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: CreateTrigger.java,v 1.6 2004/02/12 00:17:55 bradford Exp $
 */

import com.dbxml.db.client.CollectionClient;
import com.dbxml.util.dbXMLException;
import com.dbxml.xml.dom.DOMHelper;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * CreateTrigger (MKIDX) registers a Trigger under the current
 * context Collection.
 */

public final class CreateTrigger extends CreateBase {
   private static final String CLASS = "class";

   protected String getType() {
      return "Trigger";
   }

   protected boolean createObject(CollectionClient col, String name, Properties props) throws dbXMLException {
      try {
         String cname = props.getProperty(CLASS);
         if ( cname == null || cname.length() == 0 )
            throw new dbXMLException("Class name is required");

         Document doc = DOMHelper.newDocument();
         Element root = doc.createElement("trigger");
         root.setAttribute("name", name);
         doc.appendChild(root);

         Iterator iter = props.entrySet().iterator();
         while ( iter.hasNext() ) {
            Map.Entry entry = (Map.Entry)iter.next();
            String key = (String)entry.getKey();
            String value = (String)entry.getValue();
            root.setAttribute(key, value);
         }

         return col.createTrigger(doc) != null;
      }
      catch ( Exception e ) {
         throw new dbXMLException(e);
      }
   }
}

